#!/usr/bin/env python3
# -*- coding: UTF-8 -*-
#version=[2022.09.14]

import regex as re

usernameBlackWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|\\b[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*\\b|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:։|ꓽ|܃|⁚|ઃ|︰|:|꞉|ː|˸|᠉|᛬|：|ः|᠃|∶|܄|׃)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𑢯|𝟰|𝟒|4|🯴|Ꮞ|𝟺|𝟜|ꮞ|𑣏|𝟦)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𑢯|𝟰|𝟒|4|🯴|Ꮞ|𝟺|𝟜|ꮞ|𑣏|𝟦)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|Ꭺ|Ã|𝔄|𝗮|𝔸|Ậ|ă|ẵ|Ẳ|Ạ|Α|ǡ|ǟ|𝐚|𝓐|Ȃ|𝛂|ā|𝓪|Ȁ|Ả|ᴀ|ȁ|ꓮ|⍺|Ȧ|𝜶|А|𝚊|𝖠|𝚨|𝒶|𝒂|ẳ|ᗅ|Ǟ|ḁ|𝘼|Ẫ|Ḁ|ầ|𝑎|Ắ|ɑ|𝖆|𝞪|a|ǻ|â|ấ|𝘢|Ă|𝛢|𝒜|𝕬|Á|ậ|𝖺|𝛼|𝐴|ȧ|Å|ẚ|𝝰|å|𝞐|α|ằ|ắ|𝑨|Ǡ|Ẩ|𝘈|ặ|Ａ|Å|𝗔|ạ|𝕒|Ą|ẩ|Ǻ|𝙖|á|Ằ|ã|𝔞|Ǎ|𐊠|ａ|Ẵ|Ầ|ả|𝐀|𝙰|Ɑ|À|@|ä|Â|ẫ|Ā|𝝖|а|ǎ|𖽀|ȃ|à|𝜜|Ấ|ą|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:܂|\.|܁|۰|ꓸ|٠|꘎|․|𝅭|𐩐)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:٭|∗|⁎|\*|𐌟)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:٭|∗|⁎|\*|𐌟)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|Ꭺ|Ã|𝔄|𝗮|𝔸|Ậ|ă|ẵ|Ẳ|Ạ|Α|ǡ|ǟ|𝐚|𝓐|Ȃ|𝛂|ā|𝓪|Ȁ|Ả|ᴀ|ȁ|ꓮ|⍺|Ȧ|𝜶|А|𝚊|𝖠|𝚨|𝒶|𝒂|ẳ|ᗅ|Ǟ|ḁ|𝘼|Ẫ|Ḁ|ầ|𝑎|Ắ|ɑ|𝖆|𝞪|a|ǻ|â|ấ|𝘢|Ă|𝛢|𝒜|𝕬|Á|ậ|𝖺|𝛼|𝐴|ȧ|Å|ẚ|𝝰|å|𝞐|α|ằ|ắ|𝑨|Ǡ|Ẩ|𝘈|ặ|Ａ|Å|𝗔|ạ|𝕒|Ą|ẩ|Ǻ|𝙖|á|Ằ|ã|𝔞|Ǎ|𐊠|ａ|Ẵ|Ầ|ả|𝐀|𝙰|Ɑ|À|@|ä|Â|ẫ|Ā|𝝖|а|ǎ|𖽀|ȃ|à|𝜜|Ấ|ą|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:࿕|卐)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:卍|࿖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

usernameNovidBlackWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|〇|Ṑ|𝛰|ŏ|ס|Ö|ô|൦|ō|Ŏ|Ồ|Ọ|𝔬|Ộ|Ô|𞸤|Ȍ|𝞂|ం|ǒ|𑓐|Ṍ|𐊫|Ȱ|о|ȭ|Ỏ|೦|ە|߀|𝞞|𝞼|Ợ|𝝈|ő|Ǫ|ﻬ|Ȯ|𝓞|Ǒ|𝘰|౦|σ|𝞸|০|𑣠|𐐬|𝗢|𝚶|Ò|ổ|O|Ō|Օ|𝑂|𑢵|𝕠|ọ|O'|ﮫ|ⵔ|௦|õ|ớ|ﻫ|ợ|ó|ố|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|𝖮|Ο|o|𝕆|𝟢|𝙊|ö|ﮭ|ം|𝑜|ồ|𝙤|ه|۵|𝓸|ò|ﮧ|𝚘|𝟎|ಂ|𝛐|०|ỏ|ỗ|𝜊|𐔖|𝔒|ȏ|ං|၀|ờ|𝝄|ﮬ|੦|ℴ|ꬽ|ဝ|ﮪ|𝖔|𝟘|𐓪|Ȭ|𝒪|𝐎|𝜪|ᴑ|Ố|ỡ|Ȫ|𝕺|ﻩ|𑣈|𝒐|𝟶|ṏ|ﮦ|🯰|Ｏ|ȱ|ǫ|Ő|Õ|𝗼|໐|ộ|Ỗ|𝟬|Ȏ|0|ο|Ỡ|Ớ|Ở|ھ|𝙾|𑣗|𝜎|ǭ|૦|Ổ|𝝾|ہ|ଠ|օ|Ó|ơ|ｏ|๐|ﮩ|ở|ṍ|𑣕|𝝤|𞹤|ȫ|Ⲟ|𐓂|ṑ|Ṏ|ഠ|ȯ|ṓ|𝘖|𐊒|𝑶|Ǭ|𝛔|ᴏ|Ơ|୦|𝐨|𝗈|ჿ|ⲟ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

blackAdWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

redAdWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔵|𝘹|𝓧|𝘅|Ｘ|𝗫|𝐱|𝝬|𝘟|𝑥|𝚇|ⲭ|𝒙|᙭|X|Χ|ⅹ|𝖝|𝛸|Ẍ|𝙭|𑣬|𝝌|𐌢|ⵝ|𝑋|𝛘|𝞆|𐊴|×|x|Ꭓ|𝕏|𝑿|𝖃|𝜲|ꭕ|𝗑|ᕁ|ｘ|𝒳|𐊐|𝙓|𝚾|х|𐌗|𝖷|⤫|⤬|╳|𝔁|𝟀|Х|𝞦|𝔛|⨯|ᕽ|𝕩|ꓫ|ᚷ|Ⅹ|Ⲭ|𝚡|χ|ẋ|Ẋ|𝐗|𐔧|ꭓ|𝓍|᙮|𝜒|ẍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ḷ|ן|𝟭|𝘐|𐌠|ǀ|𝗹|ι|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|ỉ|ⵑ|𝓲|𞺀|𝗜|ḽ|𖼨|𝟙|ȉ|ͺ|𝟏|𑢣|í|ḻ|Ǐ|ı|𝑙|Ⲓ|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|İ|𝚕|𝝸|𝗂|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𑣃|𝛊|𝘭|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|Ĭ|ȋ|ì|ḭ|𝕝|ľ|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ï|ꙇ|ĩ|Ị|𝔩|l|𞸀|ᛁ|𝚒|Ⅰ|𝚤|ĺ|𝕀|ⅰ|𝜤|ï|ا|𝘪|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:٭|∗|⁎|\*|𐌟)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:٭|∗|⁎|\*|𐌟)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔵|𝘹|𝓧|𝘅|Ｘ|𝗫|𝐱|𝝬|𝘟|𝑥|𝚇|ⲭ|𝒙|᙭|X|Χ|ⅹ|𝖝|𝛸|Ẍ|𝙭|𑣬|𝝌|𐌢|ⵝ|𝑋|𝛘|𝞆|𐊴|×|x|Ꭓ|𝕏|𝑿|𝖃|𝜲|ꭕ|𝗑|ᕁ|ｘ|𝒳|𐊐|𝙓|𝚾|х|𐌗|𝖷|⤫|⤬|╳|𝔁|𝟀|Х|𝞦|𝔛|⨯|ᕽ|𝕩|ꓫ|ᚷ|Ⅹ|Ⲭ|𝚡|χ|ẋ|Ẋ|𝐗|𐔧|ꭓ|𝓍|᙮|𝜒|ẍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𝘭|𝔏|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝟠|𞣋|𝟪|𐌚|8|𝟾|𝟴|𝟖|🯸|Ȣ|৪|੪|ȣ|ଃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:᛭|𐊛|\+|➕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

yellowAdWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|Ꭺ|𝔄|Ã|𝔸|Ậ|𝗮|ă|ẵ|Ẳ|Ạ|Α|ǡ|ǟ|𝓐|Ȃ|𝐚|𝛂|ā|𝓪|Ȁ|ᴀ|ꓮ|Ả|ȁ|Ȧ|⍺|𝜶|А|𝖠|𝚊|𝚨|𝒶|𝒂|ᗅ|ẳ|Ǟ|ḁ|𝘼|Ẫ|Ḁ|ầ|𝑎|Ắ|ɑ|𝖆|𝞪|a|ǻ|â|ấ|𝘢|Ă|𝛢|𝒜|𝕬|Á|ậ|ꭺ|𝖺|𝛼|𝐴|ȧ|A|Å|å|𝝰|𝞐|α|ằ|ắ|𝑨|Ǡ|Ẩ|𝘈|ặ|Ａ|𝗔|Å|ạ|𝕒|Ą|Ǻ|ẩ|𝙖|á|Ằ|ã|Ǎ|𝔞|ａ|Ẵ|Ầ|ả|𝐀|𝙰|À|@|ä|Â|ẫ|Ā|𝝖|а|ǎ|𖽀|ȃ|à|𝜜|Ấ|ą|Ä|𐊠)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

usernameRedWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:⸜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:⟋|〳|⼃|⁄|丿|ⳇ|ノ|∕|㇓|𝈺|⧸|╱|᜵|Ⳇ|⁁|/)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

textBlackWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

doubledSusWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔵|𝘹|𝓧|𝘅|Ｘ|𝗫|𝐱|𝝬|𝘟|𝑥|𝚇|ⲭ|𝒙|᙭|X|Χ|ⅹ|𝖝|𝛸|Ẍ|𝙭|𑣬|𝝌|𐌢|ⵝ|𝑋|𝛘|𝞆|𐊴|×|x|Ꭓ|𝕏|𝑿|𝖃|𝜲|ꭕ|𝗑|ᕁ|ｘ|𝒳|𐊐|𝙓|𝚾|х|𐌗|𝖷|⤫|⤬|╳|𝔁|𝟀|Х|𝞦|𝔛|⨯|ᕽ|𝕩|ꓫ|ᚷ|Ⅹ|Ⲭ|𝚡|χ|ẋ|Ẋ|𝐗|𐔧|ꭓ|𝓍|᙮|𝜒|ẍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

textObfuBlackWordsCompiledPairs = [(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "gaelrmt"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "gaerb"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕕|𝔡|𝖉|ḑ|ԁ|Ꮷ|𝐝|Ḑ|ꓒ|Ꭰ|Ⅾ|ᑯ|d|𝑑|ḏ|𝒅|ḓ|𝓭|𝖣|𝔇|𝐷|𝒟|ᗞ|𝔻|ⅅ|ⅾ|𝒹|ⅆ|Ḓ|ꭰ|Ḏ|𝗗|𝖽|D|ꮷ|ᴅ|ď|ꓓ|𝘥|ᗪ|ḍ|Ḋ|Ď|Ԁ|𝘿|𝙳|𝗱|𝙙|𝓓|𝑫|ḋ|𝚍|𝐃|𝘋|Ḍ|𝕯)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "aesyrdm ivo"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "nesymc ito"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚼|𝛶|ꓬ|𝙔|ÿ|ℽ|ỿ|Ⲩ|𝒚|𑣄|𝔂|Ỿ|𝗒|ỹ|𝖞|Υ|𝜸|ϒ|ყ|𝕐|ɣ|𝚢|Ꭹ|Ꮍ|ｙ|ꭚ|𝝲|𝖸|𑢤|ŷ|ý|𝒴|u|υ|𝛾|Ȳ|ꭹ|𝐘|𝑌|𐊲|ỵ|z|𝒀|𝞬|Ɣ|ⲩ|ʏ|Ÿ|Ү|ꮍ|𝜰|Ý|ү|𝖄|У|Ỷ|𖽃|Ỳ|𝞤|𝔶|ẏ|𝐲|ỳ|𝑦|Γ|ẙ|𝙮|𑣜|ȳ|𝝪|𝓨|𝔜|y|𝘺|ỷ|Y|Ẏ|𝕪|у|Ყ|𝗬|Ｙ|𝓎|𑢼|Ŷ|Ỵ|ᶌ|𝘆|Ỹ|𝛄|γ|𝘠|𝚈)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "onaeymcw ts"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "ungelrhi b"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "ngelrh ito"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ń|𝙉|ṉ|𝗇|Ñ|Ṇ|ǹ|Ռ|𝚴|Ṋ|𝕟|𝒩|Ν|𝑁|𝙣|𝓃|ν|Ń|𝜨|ɴ|Ņ|𝕹|𝗻|𝘕|Ň|𝖓|𝚗|ṅ|ꓠ|𝑛|ṇ|𝖭|Ǹ|Ṅ|Ⲛ|𝘯|ɲ|ⲛ|ռ|ո|ṋ|ｎ|𝒏|Ｎ|𝓝|ℕ|𝗡|𝝢|N|𝔫|n|𝐍|Ո|ñ|v|𝛮|𝔑|ň|ņ|𝞜|𝓷|𐔓|𝑵|𝐧|Ṉ|𝙽)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "nerc bto"),]

usernameObfuBlackWordsCompiledPairs = [(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "ukcbvs"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "ukc bvs"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔵|𝘹|𝓧|𝘅|Ｘ|𝗫|𝐱|𝝬|𝘟|𝑥|𝚇|ⲭ|𝒙|᙭|X|Χ|ⅹ|𝖝|𝛸|Ẍ|𝙭|𑣬|𝝌|𐌢|ⵝ|𝑋|𝛘|𝞆|𐊴|×|x|Ꭓ|𝕏|𝑿|𝖃|𝜲|ꭕ|𝗑|ᕁ|ｘ|𝒳|𐊐|𝙓|𝚾|х|𐌗|𝖷|⤫|⤬|╳|𝔁|𝟀|Х|𝞦|𝔛|⨯|ᕽ|𝕩|ꓫ|ᚷ|Ⅹ|Ⲭ|𝚡|χ|ẋ|Ẋ|𝐗|𐔧|ꭓ|𝓍|᙮|𝜒|ẍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "urxbo"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|ꞵ|𝓫|Ḅ|B|ᑲ|ʙ|𝓑|𝒷|𝐵|в|Ḇ|ℬ|ᗷ|β|ь|𝝗|𝗕|𐊂|𝖡|Ƅ|𝚋|b|𝙱|ꮟ|𝖇|𐊡|𝔅|Ꞵ|В|Ь|𝚩|𝙗|Ᏼ|𐌁|𝑩|𝞑|𝔹|𝛣|𝔟|𝘉|𝘣|𝒃|𝗯|𝖻|𝐛|𝘽|ḇ|ϐ|ḃ|ｂ|Ꮟ|ᏼ|𝑏|Ḃ|ß|Β|𝕭|𝜝|ḅ|𝕓|ƅ|𝐁|ꓐ|ᖯ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "uksrcbo"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔵|𝘹|𝓧|𝘅|Ｘ|𝗫|𝐱|𝝬|𝘟|𝑥|𝚇|ⲭ|𝒙|᙭|X|Χ|ⅹ|𝖝|𝛸|Ẍ|𝙭|𑣬|𝝌|𐌢|ⵝ|𝑋|𝛘|𝞆|𐊴|×|x|Ꭓ|𝕏|𝑿|𝖃|𝜲|ꭕ|𝗑|ᕁ|ｘ|𝒳|𐊐|𝙓|𝚾|х|𐌗|𝖷|⤫|⤬|╳|𝔁|𝟀|Х|𝞦|𝔛|⨯|ᕽ|𝕩|ꓫ|ᚷ|Ⅹ|Ⲭ|𝚡|χ|ẋ|Ẋ|𝐗|𐔧|ꭓ|𝓍|᙮|𝜒|ẍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "exs"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ա|ẁ|𝗪|𑣦|𝙬|Ẅ|𑜊|𝗐|𑣯|Ԝ|𝕎|ẇ|𝑊|ꮤ|Ꮤ|Ẃ|𝖜|Ɯ|𝚆|ѡ|ꮃ|𑜎|𝔴|Ѡ|𝙒|Ŵ|ẅ|Ẇ|w|W|Ẁ|ԝ|ẉ|ᴡ|𝔚|𝑤|𝓦|𝓌|ɯ|ẘ|𝐖|𝒲|𝖶|𝒘|𝔀|Ẉ|𝖂|ẃ|𝑾|ꓪ|Ꮃ|Ա|𝕨|𝚠|𝐰|𝘸|𑜏|𝘞|𝘄|ŵ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:տ|𝖋|Ṡ|𝐬|𝓼|𝔣|𝒮|𖼺|𝔰|𝓢|𝙛|ƽ|𝑓|Տ|𝚜|𝓈|ꓢ|𝘴|𝚂|Ś|𝐟|ș|𝖿|Ş|ś|𝙨|Ｆ|ꮪ|f|ḟ|𝑠|ṡ|𝕊|Ƽ|𝖘|ṣ|𝙎|𑢡|ṧ|𝐒|ŝ|𝘧|Ṣ|𝚏|ṩ|Ｓ|𐐠|Ꮪ|š|𝒻|F|Ꮥ|ş|𝘚|ք|𝓯|Ѕ|𝕾|𝑺|ẝ|s|𝑆|𐊖|S|ꜱ|𝗌|ꞙ|Ṥ|ｓ|Ŝ|Ș|Š|𝘀|ṥ|𐑈|𝕤|ѕ|𝒇|𝔖|𝒔|ꮥ|Ṧ|Ṩ|𝗦|ſ|ғ|𑣁|𝖲|ꬵ|𝗳|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|ℙ|ρ|𝛒|𝘱|𝙋|𝜬|𝐏|ᑭ|ṗ|𝑝|𝕡|Ṗ|𐊕|𝚸|𝗉|ᴩ|𝘗|𝕻|Ｐ|𝒫|𝙥|𝜌|𝗣|𝞠|𝜚|ꓑ|𝗽|𝓅|ꮲ|𝝆|ｐ|𝔭|Ρ|𝐩|𝚙|Ⲣ|Р|Ꮲ|𝟈|𝞎|P|ϱ|𝑃|ⲣ|𝑷|ṕ|𝖕|𝞺|𝓟|Ṕ|𝔓|𝛲|𝒑|р|⍴|𝛠|𝝔|ᴘ|𝖯|𝙿|p|𝝦|𝓹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "ahwtps"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "gaelrmt"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙃|𝗵|Ḩ|𝒽|ẖ|𝐻|η|n̩|Ꮒ|ꮋ|Ḫ|𝖧|𝘏|ḫ|ꮒ|𝗛|ᕼ|𝝜|𝓱|𝗁|𝘩|ĥ|ℍ|𝓗|𝖍|𝜢|𐋏|ʜ|𝐡|ȟ|𝕳|Ĥ|𝐇|𝚮|𝔥|𝞖|H|ḥ|ⲏ|ℎ|հ|𝙷|𝛨|Н|н|h|ḣ|ｈ|Հ|ꓧ|һ|𝑯|Ȟ|Ꮋ|𝕙|𝚑|Ｈ|Ḥ|ḧ|Ḧ|Һ|𝙝|Η|Ḣ|Ⲏ|𝒉|ℌ|ℋ|ḩ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ዐ|ȍ|٥|О|𑢷|ס|Ö|Σ|ô|൦|Ŏ|Ọ|𝔬|Ộ|Ȍ|ం|Ṍ|Ȱ|ȭ|Ỏ|೦|Ꭴ|𝞞|𝝈|Ǫ|ﻬ|σ|𐐬|𑣠|𝗢|𝚶|Ò|𑢵|𝕠|ọ|ﮫ|ﻫ|ó|𐐄|Ờ|Ṓ|𞺄|ꓳ|ﻪ|ﮨ|Ο|o|𝕆|𝟢|𝙊|ồ|𝙤|ه|۵|𝓸|ò|𝟎|ಂ|𝛐|ỗ|𝜊|𐔖|၀|𝝄|ﮬ|੦|ꬽ|ဝ|𝟘|Ȭ|𝐎|𝜪|ᴑ|ỡ|Ȫ|𝕺|𑣈|ṏ|ﮦ|Ｏ|ȱ|ǫ|Ő|6|Õ|ة|𝟬|ο|Ỡ|Ở|𑣗|ǭ|ଠ|օ|ơ|ｏ|๐|ở|Ⲟ|𐓂|Ṏ|ഠ|𝘖|𐊒|ȯ|Ǭ|𝐨|𝗈|ⲟ|〇|Ṑ|𝛰|ŏ|ō|Ồ|Ô|𞸤|𝞂|ǒ|𑓐|𐊫|о|ە|߀|𝞼|Ợ|ő|Ȯ|𝓞|o'|Ǒ|𝘰|౦|𝞸|০|ổ|O|Ō|Օ|𝑂|𑢨|O'|ⵔ|௦|õ|ớ|ợ|Ჿ|ố|𝖮|ö|ﮭ|ം|𝑜|ﮧ|𝚘|०|ỏ|𝔒|ȏ|ං|ờ|ℴ|ﮪ|𝖔|𐓪|𝒪|Ố|ﻩ|𝒐|𝟶|🯰|𝗼|Ỗ|໐|ộ|Ȏ|0|Ớ|𝙾|ھ|Ổ|𝜎|૦|𝝾|ہ|Ó|ﮩ|ṍ|𑣕|𝝤|𞹤|ȫ|ṑ|ṓ|𝑶|Ơ|ᴏ|𝛔|୦|ჿ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ⲧ|𝛵|Ꭲ|𝕥|Ｔ|τ|Τ|ţ|𝑇|ƫ|𝞃|Ṫ|𝛕|т|ⲧ|𝝩|𐊱|𝚝|𝓉|𝐓|Ṱ|𝖙|ͳ|Ţ|𝑡|Ͳ|𝓽|Ț|ꭲ|𝙏|Т|𝘁|Ṭ|𝜏|ꓔ|𑣜|𖼊|𝒯|ṱ|𝖳|t|ｔ|Ṯ|𝗧|y|ẗ|𝘵|𝔱|𝔗|𝚻|𝓣|⊤|𝝉|ț|ṫ|𝜯|𝒕|ť|🝨|𝕋|𝕿|𝘛|𝐭|𝙩|𑢼|⟙|𝞣|T|𝚃|𝑻|Ť|ṯ|𐊗|𐌕|ᴛ|𝞽|𝗍|ṭ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ġ|𝙜|Ǵ|𝔾|ĝ|Ḡ|ꮐ|ɡ|ɠ|ɢ|G'|ᶃ|Ｇ|ᏻ|𝘨|Ɠ|Ᏻ|𝑮|𝙶|Ԍ|𝗀|𝘎|ԍ|ℊ|ց|𝐺|𝓖|ģ|Ǧ|Ց|ğ|𝚐|𝕲|𝐆|Ɡ|Ğ|g|𝗚|ꓖ|ġ|𝒈|Ꮐ|ǵ|ǧ|Ģ|Ĝ|g̔|ƍ|G|𝑔|𝗴|ḡ|𝓰|𝔤|𝔊|𝙂|ｇ|𝒢|𝖦|𝐠|𝕘|𝖌)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔯|𝙍|ȑ|Ꮢ|ꮢ|𝐑|Ṝ|𝗥|𝖗|𝚁|Ｒ|ŕ|𝑹|ꭱ|Ř|ṟ|ṝ|ŗ|𝕽|𝕣|Ꮁ|𝈖|Ṟ|𝘙|ṛ|𝗿|𐒴|ⲅ|ȓ|𝓡|𝚛|Ṙ|ꭈ|ᖇ|ᴦ|ʀ|Ŗ|𝙧|𝓇|𝗋|r|Ṛ|𐓜|Г|г|ř|𝑅|ꮁ|Ʀ|Ȑ|ꭇ|ℜ|ｒ|𝘳|𝒓|Ȓ|ṙ|ℝ|ꓣ|𝐫|𝑟|ɾ|𖼵|Ꭱ|𝖱|R|𝓻|Ŕ|Ⲅ|ℛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "glrh ito"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḟ|𝗙|𝟋|ք|Ϝ|Γ̵|𝖥|𐔥|𐊥|𝖋|𝔣|𝓯|𝙵|𝙛|ẝ|𝙁|𝕱|𝑓|ℱ|𝈓|S|r̵|ꓝ|𝐟|𝔉|ꞙ|𝖿|Ｆ|Ꞙ|ᖴ|𝟊|f|Ք|𑣂|ḟ|𝓕|𝒇|𑢢|ɍ|𝐅|𐊇|ｆ|ғ|𝘧|ſ|𝑭|𝔽|𝚏|ꜰ|𝐹|ϝ|ꬵ|𝘍|𝗳|Ғ|𝒻|F|𝕗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ử|ữ|Ŭ|𝑼|Ȗ|𐓶|Ṹ|ŭ|𑢸|ꭎ|ȗ|Ṷ|Ư|Υ|ứ|Û|Ǔ|Ṵ|ṳ|ú|𝝊|𝑈|U|𝗨|𝗎|ṹ|𝔘|𝕦|𝞄|Ü|Ů|ǘ|∪|ᑌ|ų|u|𝖀|Ǖ|ṵ|υ|𝓤|𝘜|ꓴ|Ṻ|Ũ|ù|ư|ử|Ｕ|𑣘|Ủ|Ṳ|ᴜ|𝛖|Ǜ|Ս|Ų|ũ|ȕ|Ǘ|ű|Ụ|𝙪|𝖴|ǜ|ꭒ|ṻ|𝑢|𝘂|𖽂|Ứ|ṷ|𝓾|ů|𝒰|𝐮|Ű|ự|𝖚|ʋ|Ữ|𝘶|Ū|𝔲|ụ|ừ|𝚞|𝞾|Ừ|𝕌|Ự|ꞟ|⋃|ሀ|𐓎|𝚄|Ú|Ù|ǚ|Ȕ|ｕ|𝐔|𝜐|ü|𝓊|ū|Ǚ|𝒖|û|ủ|ǖ|𝙐|ǔ|ս|Ꞟ|Ʋ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞌|𝛫|Κ|𝑲|𝚔|k|𝙠|𝟆|ǩ|Ķ|𝘬|𝗞|𝗄|ᴋ|𝓴|𝙆|𝕶|𝕜|𝔨|𝘒|ḵ|𝓚|𝝟|𝝹|𝚱|Ḵ|ϰ|𝐊|𝔎|𝖐|𝑘|Ｋ|𝞙|𝜘|ᛕ|𝛞|Ⲕ|Ḳ|𝜅|ｋ|𐔘|𝛋|ꮶ|ḳ|К|ķ|𝞳|Ǩ|ĸ|𝓀|𝝒|𝜥|𝗸|K|𝒦|𝙺|Ꮶ|к|κ|𝒌|𝜿|Ḱ|𝐾|𝖪|𝕂|𝐤|K|ḱ|ꓗ|ⲕ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "ufck"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ꓡ|ι|𝞘|ߊ|ꓲ|ḹ|1|I|Ḹ|𝙇|Ḻ|Ľ|𞺀|𝗜|𐑃|𝓛|ḽ|𖼨|𝙻|𝟙|𝟏|𝖫|𑢣|Ｌ|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|Ĩ|∣|Í|𐊊|ɩ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|i|ӏ|𝒍|ⅼ|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|𞣇|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝝞|ו|Ḯ|Ì|ꮮ|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𑣒|𝕷|ⲓ|Î|Į|Ȋ|𝖨|𝐼|\||𝐥|𝑳|𑣃|𝔏|𝘭|𝙸|𝖑|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|𝈪|𝕃|ľ|𝕝|𝟣|𝓁|𝟷|׀|Ĺ|Ï|Ị|𝗟|𝔩|l|𞸀|ᛁ|Ꮮ|Ⅰ|ĺ|𝘓|𝕀|ⅰ|𝜤|ⳑ|ا|𝐋|Ļ|ʟ|Ｉ|ℐ|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝗅|𝒾|ͅ|ן|ḷ|ᒪ|𝟭|𝘐|ℒ|𐌠|Ⳑ|ǀ|𝗹|ι|ꓡ|𝞘|ߊ|ꓲ|ḹ|⍳|𝜄|𝐢|ꭵ|𝜾|I|1|𝔦|Ḹ|ỉ|𝙇|ⵑ|Ľ|𝓲|𞺀|Ḻ|𝗜|ḽ|𝓛|𖼨|𝙻|𝟙|ȉ|ͺ|𝟏|𝖫|𑢣|Ｌ|í|ḻ|Ǐ|ı|𝑙|Ⲓ|𐐛|ḯ|Ĩ|∣|Í|ī|𝖎|ɩ|𐊊|ǃ|Ⅼ|Ȉ|ļ|Ī|Ḭ|ｌ|🯱|𑢲|ị|i|𝞲|ӏ|𝒍|ℹ|ⅼ|𝒊|𝛪|ﺍ|𝙡|Ӏ|￨|ｉ|ⵏ|ℓ|Ḷ|𝓘|！|Ꭵ|𞣇|ⅈ|𐌉|⏽|١|Ḽ|𝑰|Ỉ|𝙄|۱|ɪ|𝙞|𝝞|Ḯ|Ì|ו|𝓵|Ɩ|𝚰|𐔦|İ|𝚕|𝝸|𝗂|𝕷|ⲓ|Î|Į|į|Ȋ|𝖨|ĭ|𝐼|𝗶|ǐ|\||𝐥|𝑳|𑣃|𝛊|𝘭|𝔏|𝙸|𝖑|î|І|𝐈|ﺎ|Ι|L|ℑ|𖼖|Ĭ|ȋ|ì|𝈪|𝕃|ḭ|ľ|𝕝|𝟣|𝓁|˛|𝟷|׀|Ɪ|Ꙇ|Ĺ|Ï|ꙇ|ĩ|Ị|𝗟|𝔩|l|𞸀|ᛁ|𝚒|Ꮮ|Ⅰ|𝚤|ĺ|𝘓|𝕀|ⅰ|𝜤|ï|ا|𝘪|𝐋|Ļ|ʟ|Ｉ|𝑖|ℐ|𝕚|𝕴|і|ι|!|𝐿)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝙫|Ṿ|𝝼|𝒱|𝑽|Ⅴ|ⅴ|ꛟ|𝖛|𝙑|ⴸ|𝕧|Ν|ν|ᐯ|𖼈|𝓿|⋁|𝞶|ꮩ|𑣀|𝖵|𐔝|٧|𝗩|Ѵ|ṽ|𝘝|𝔳|Ｖ|𝝂|V|ṿ|𝕍|𝜈|ｖ|𝑉|𝚟|۷|𑜆|ᴠ|𝑣|𝈍|𝓋|ѵ|𝓥|𝗏|Ṽ|𝚅|𝛎|v|Ꮩ|ꓦ|𑢠|𝖁|𝔙|∨|𝐕|𝘃|𝒗|𝘷|𝐯|ט)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ꭼ|ể|𝓔|ꝫ|𝈆|𝖾|ė|𑣎|ᴇ|𑢪|ȩ|𝝐|𝝚|𑣊|ԑ|𝟹|𝕰|𝙀|ȇ|𝟯|ꓰ|𝚎|𝞮|Ḗ|ḝ|ℰ|𝐄|Ề|7|3|ɜ|ꮛ|Ể|е|é|Ễ|ȅ|Е|Ｅ|Ɜ|Ĕ|ê|ḕ|ⴹ|ⅇ|Ȝ|È|Ⳍ|ẽ|ễ|𝕖|Ȇ|ϵ|Ȩ|𝛆|Ę|𝔢|Ẻ|𝖊|É|ꞓ|𝐞|Ḝ|ẹ|🯳|Ε|⋴|ẻ|è|ề|ꬲ|ℯ|𝛜|𝜀|E|є|𑢮|𝟑|Ē|𝞊|𝑒|Ė|𝓮|ⲉ|𑣆|ệ|Ʒ|𝜖|ҽ|𝟥|𐐩|Ꭼ|𝖤|Ḕ|Ẹ|ḗ|ě|Ë|ȝ|З|ʒ|℮|𝒆|𝛦|Ẽ|з|ế|ӡ|ｅ|ɛ|Ệ|Ӡ|ḛ|𝚬|Ế|𝘌|𝗲|Ҽ|Ꞓ|𝐸|𖼻|⋿|Ě|Ꝫ|𝝴|𝟛|𝞔|𝜠|e|𝟄|ę|ë|ⳍ|𝑬|𝔼|ε|𝔈|Ê|ĕ|𝜺|𝙴|𝘦|Ḙ|ḙ|Є|𐊆|Ȅ|Ḛ|𝙚|𑢦|𝗘|ē)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | |\ | | | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖼|𐔜|𝔠|ĉ|𝚌|Ĉ|Ḉ|Č|🝌|Ꮯ|C|ℂ|Ｃ|ｃ|ć|С|Ҫ|c̦|c|Ć|𝒞|ⅽ|𝓬|𝕮|𑣩|𝑪|𝗖|ç|Ϲ|𝒸|ℭ|𝕔|Ç|Ċ|𐐕|𐐽|𝐂|𝒄|𝘊|ϲ|𝓒|𝙲|ꮯ|𝐜|Ⅽ|C̦|𝗰|𐌂|Ⲥ|𐊢|𝐶|𝑐|ċ|𝘾|𝘤|ꓚ|ᴄ|𝙘|𝖈|с|ⲥ|𑣲|č|𝖢|ḉ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ặ|𝔄|𝔸|ẵ|Ẳ|Ạ|ǡ|ǟ|𝓐|𝛂|ā|𝓪|Ȁ|ȁ|Ȧ|⍺|𝜶|А|𝚨|𝒶|𝒂|Ǟ|ḁ|Ẫ|ầ|𝑎|Ắ|𝖆|𝞪|â|𝛢|𝕬|𝘢|𝐴|Å|ẚ|𝝰|𝞐|α|ằ|ắ|Ẩ|𝘈|Ａ|𝗔|𝕒|Ǻ|ẩ|𝙖|á|Ằ|Ǎ|𝔞|Ẵ|𝙰|Ɑ|À|𖽀|ȃ|𝜜|ą|𐊠|Ꭺ|Ã|Ậ|𝗮|ă|Α|Ȃ|𝐚|ᴀ|ꓮ|Ả|𝖠|𝚊|ᗅ|ẳ|𝘼|Ḁ|ɑ|a|ǻ|ấ|𝒜|Ă|Á|ậ|ꭺ|𝖺|𝛼|ȧ|å|𝑨|Ǡ|ặ|Å|ạ|Ą|ã|ａ|Ầ|ả|𝐀|@|Â|ä|ẫ|Ā|𝝖|а|ǎ|à|Ấ|Ä|A)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞛|𝒎|𝓜|ⲙ|𝙢|𝛭|𝗆|ꭑ|𝗠|Ϻ|Ꮇ|𑣣|ｍ|𝛍|𝕄|𝑴|ⅿ|𝔐|Ｍ|М|ʍ|𝐦|𝚳|μ|𝝡|Ṁ|ᛖ|ᴍ|𝔪|𑜀|m|𝙼|ᗰ|𝖬|𝜇|ꓟ|𝕞|𝑚|𝜧|ḿ|ϻ|𝘔|ṃ|𝚖|𝝁|𝘮|Ⅿ|𝖒|𝙈|Ḿ|𝕸|𝐌|ꮇ|𝞵|M|𝑀|Μ|м|𐌑|𝝻|ṁ|ℳ|Ⲙ|rn|𝓶|µ|𐊰|𝓂|𝗺|Ṃ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "aelmc iv"),]

threadPhrasesRegex = r"([w-wW-W](n{8})?[i-iI-I](p{5})?[t-tT-T](y{5})?[h-hH-H](M{7})? [e-eE-E](h{8})?[x-xX-X](x{5})?[p-pP-P](q{8})?[e-eE-E](i{8})?[r-rR-R](I{7})?[t-tT-T](B{6})?|[e-eE-E](T{8})?[x-xX-X](Q{6})?[p-pP-P](k{8})?[e-eE-E](Z{5})?[r-rR-R](i{7})?[t-tT-T](A{4})? [m-mM-M](i{4})?[r-rR-R](N{8})?|[e-eE-E](O{8})?[x-xX-X](W{6})?[p-pP-P](B{4})?[e-eE-E](k{8})?[r-rR-R](A{5})?[t-tT-T](J{4})? [m-mM-M](F{4})?[r-rR-R](s{4})?[s-sS-S](a{6})?|[c-cC-C](T{8})?[o-oO-O](i{7})?[n-nN-N](B{5})?[t-tT-T](g{5})?[a-aA-A](M{7})?[c-cC-C](Z{4})?[t-tT-T](e{8})? [m-mM-M](N{7})?[r-rR-R](G{7})?|[c-cC-C](Q{7})?[o-oO-O](W{4})?[n-nN-N](l{5})?[t-tT-T](D{4})?[a-aA-A](b{8})?[c-cC-C](J{4})?[t-tT-T](Y{5})? [m-mM-M](m{5})?[r-rR-R](j{7})?[s-sS-S](G{8})?|[c-cC-C](J{4})?[o-oO-O](B{7})?[n-nN-N](L{8})?[t-tT-T](Z{6})?[a-aA-A](c{8})?[c-cC-C](V{7})?[t-tT-T](G{7})? [h-hH-H](e{6})?[i-iI-I](a{5})?[m-mM-M](U{6})?|[c-cC-C](e{6})?[o-oO-O](u{8})?[n-nN-N](Q{4})?[t-tT-T](t{8})?[a-aA-A](N{4})?[c-cC-C](m{7})?[t-tT-T](f{4})? [h-hH-H](v{6})?[e-eE-E](i{7})?[r-rR-R](I{6})?|[w-wW-W](P{8})?[r-rR-R](U{8})?[i-iI-I](c{4})?[t-tT-T](F{7})?[e-eE-E](h{4})? [h-hH-H](H{5})?[i-iI-I](S{7})?[m-mM-M](G{5})?|[w-wW-W](Q{8})?[r-rR-R](Q{4})?[i-iI-I](X{4})?[t-tT-T](L{6})?[e-eE-E](t{8})? [h-hH-H](b{7})?[e-eE-E](v{8})?[r-rR-R](r{7})?|[t-tT-T](G{6})?[e-eE-E](p{6})?[x-xX-X](q{5})?[t-tT-T](C{5})? [h-hH-H](s{4})?[i-iI-I](J{6})?[m-mM-M](T{5})?|[t-tT-T](v{4})?[e-eE-E](x{8})?[x-xX-X](x{4})?[t-tT-T](j{7})? [h-hH-H](o{4})?[e-eE-E](u{4})?[r-rR-R](n{4})?|[r-rR-R](Q{8})?[e-eE-E](r{8})?[c-cC-C](O{7})?[o-oO-O](b{6})?[m-mM-M](P{8})?[m-mM-M](F{6})?[e-eE-E](G{8})?[n-nN-N](a{8})?[d-dD-D](G{7})? [h-hH-H](N{4})?[i-iI-I](m{8})?[m-mM-M](Z{6})?|[r-rR-R](j{7})?[e-eE-E](J{8})?[c-cC-C](g{5})?[o-oO-O](Z{7})?[m-mM-M](u{4})?[m-mM-M](V{4})?[e-eE-E](I{6})?[n-nN-N](q{5})?[d-dD-D](a{7})? [h-hH-H](s{6})?[e-eE-E](T{4})?[r-rR-R](P{7})?|[c-cC-C](r{5})?[o-oO-O](O{6})?[m-mM-M](l{6})?[m-mM-M](v{6})?[u-uU-U](x{4})?[n-nN-N](E{6})?[i-iI-I](h{6})?[c-cC-C](w{7})?[a-aA-A](G{7})?[t-tT-T](H{6})?[e-eE-E](U{8})? [h-hH-H](w{6})?[i-iI-I](O{4})?[m-mM-M](c{7})?|[c-cC-C](c{4})?[o-oO-O](z{6})?[m-mM-M](z{4})?[m-mM-M](E{7})?[u-uU-U](I{4})?[n-nN-N](U{4})?[i-iI-I](M{7})?[c-cC-C](y{6})?[a-aA-A](s{7})?[t-tT-T](H{7})?[e-eE-E](C{6})? [h-hH-H](x{8})?[e-eE-E](R{4})?[r-rR-R](O{8})?)"

monetWordsRegex = r"([p-pP-P](A{4})?[r-rR-R](w{5})?[o-oO-O](s{7})?[f-fF-F](M{5})?[i-iI-I](i{6})?[t-tT-T](p{5})?|[e-eE-E](x{5})?[a-aA-A](L{7})?[r-rR-R](F{7})?[n-nN-N](a{7})?|[i-iI-I](m{5})? [m-mM-M](d{4})?[a-aA-A](X{8})?[d-dD-D](J{5})?[e-eE-E](W{7})?|[m-mM-M](j{5})?[a-aA-A](F{7})?[d-dD-D](u{6})?[e-eE-E](Z{6})? [m-mM-M](j{7})?[e-eE-E](F{6})?)"

salutationRegex = r"([m-mM-M]([r-rR-R](\.|([s-sS-S]\.?))?|[s-sS-S]\.?)|[e-eE-E](n{6})?[x-xX-X](Z{6})?[p-pP-P](Q{6})?[e-eE-E](T{8})?[r-rR-R](L{4})?[t-tT-T](J{8})?)"

nakedNamePreRegex = r"([w-wW-W](N{7})?[i-iI-I](F{4})?[t-tT-T](H{8})?[h-hH-H](o{7})?|[b-bB-B](u{6})?[r-rR-R](A{7})?[o-oO-O](G{7})?[k-kK-K](y{5})?[e-eE-E](J{5})?[r-rR-R](r{7})?|[t-tT-T](u{7})?[h-hH-H](E{4})?[a-aA-A](F{7})?[n-nN-N](e{7})?[k-kK-K](K{6})?[s-sS-S](b{4})? [t-tT-T](i{5})?[o-oO-O](Y{8})?)"

threadWordsRegex = r"([p-pP-P](L{5})?[r-rR-R](l{6})?[o-oO-O](W{6})?[f-fF-F](c{4})?[i-iI-I](A{7})?[t-tT-T](c{8})?|[c-cC-C](C{8})?[r-rR-R](S{8})?[y-yY-Y](W{4})?[p-pP-P](E{4})?[t-tT-T](E{7})?[o-oO-O](r{4})?|[c-cC-C](c{8})?[r-rR-R](u{4})?[y-yY-Y](A{4})?[p-pP-P](U{6})?[t-tT-T](B{8})?0|[b-bB-B](u{8})?[t-tT-T](z{6})?[c-cC-C](S{5})?|[b-bB-B](l{4})?[i-iI-I](P{6})?[t-tT-T](w{5})?[c-cC-C](o{7})?[o-oO-O](u{5})?[i-iI-I](q{6})?[n-nN-N](K{7})?|[t-tT-T](M{5})?[r-rR-R](K{7})?[a-aA-A](P{4})?[d-dD-D](F{6})?[i-iI-I](l{8})?[n-nN-N](o{4})?[g-gG-G](t{7})?|[t-tT-T](c{4})?[r-rR-R](m{4})?[a-aA-A](H{6})?[d-dD-D](r{8})?[e-eE-E](M{6})?|[i-iI-I](d{6})?[n-nN-N](V{4})?[v-vV-V](j{5})?[e-eE-E](D{8})?[s-sS-S](X{6})?[t-tT-T](n{6})?|[s-sS-S](w{8})?[i-iI-I](l{5})?[g-gG-G](Q{7})?[n-nN-N](t{5})?[a-aA-A](D{4})?[l-lL-L](e{8})?|[e-eE-E](E{4})?[x-xX-X](E{4})?[p-pP-P](r{7})?[e-eE-E](a{8})?[r-rR-R](N{7})?[t-tT-T](d{8})?|[p-pP-P](c{8})?[r-rR-R](Z{8})?[o-oO-O](M{4})?[f-fF-F](u{8})?[e-eE-E](F{6})?[s-sS-S](O{7})?[s-sS-S](J{5})?[i-iI-I](C{8})?[o-oO-O](l{7})?[n-nN-N](t{4})?[a-aA-A](O{7})?[l-lL-L](v{5})?|[s-sS-S](r{8})?[t-tT-T](O{6})?[r-rR-R](R{8})?[a-aA-A](Z{5})?[t-tT-T](Z{5})?[e-eE-E](b{7})?[g-gG-G](M{4})?[y-yY-Y](s{8})?|[m-mM-M](I{4})?[e-eE-E](W{8})?[t-tT-T](e{6})?[h-hH-H](h{4})?[o-oO-O](k{8})?[d-dD-D](X{7})?|[f-fF-F](M{8})?[o-oO-O](R{4})?[r-rR-R](F{6})?[e-eE-E](s{4})?[x-xX-X](m{6})?|[s-sS-S](b{5})?[u-uU-U](f{5})?[c-cC-C](P{7})?[c-cC-C](z{4})?[e-eE-E](k{7})?[s-sS-S](c{5})?[s-sS-S](M{8})?|[e-eE-E](F{4})?[a-aA-A](H{8})?[r-rR-R](b{8})?[n-nN-N](r{6})?|[o-oO-O](f{7})?[p-pP-P](V{4})?[p-pP-P](P{5})?[o-oO-O](W{6})?[r-rR-R](y{8})?[t-tT-T](O{4})?[u-uU-U](L{6})?[n-nN-N](n{6})?[i-iI-I](M{8})?[t-tT-T](n{5})?[y-yY-Y](d{4})?|[i-iI-I](E{5})?[n-nN-N](r{8})?[c-cC-C](p{5})?[o-oO-O](N{5})?[m-mM-M](K{4})?[e-eE-E](A{7})?|[p-pP-P](q{6})?[o-oO-O](j{6})?[r-rR-R](K{4})?[t-tT-T](D{5})?[f-fF-F](x{7})?[o-oO-O](A{5})?[l-lL-L](z{6})?[i-iI-I](D{6})?[o-oO-O](t{8})?|[p-pP-P](S{7})?[r-rR-R](j{8})?[o-oO-O](P{7})?[f-fF-F](n{5})?[i-iI-I](D{8})?[t-tT-T](J{7})?|[m-mM-M](b{4})?[o-oO-O](k{5})?[n-nN-N](j{7})?[e-eE-E](x{5})?[y-yY-Y](J{6})?|[s-sS-S](k{7})?[e-eE-E](p{6})?[c-cC-C](e{5})?[r-rR-R](A{6})?[e-eE-E](E{5})?[t-tT-T](b{4})?|[w-wW-W](k{5})?[e-eE-E](L{7})?[a-aA-A](s{5})?[l-lL-L](R{7})?[t-tT-T](Q{5})?[h-hH-H](B{5})?|[e-eE-E](X{8})?[a-aA-A](F{7})?[r-rR-R](d{6})?[n-nN-N](x{4})?)"

exactRedAdWords = r"(------------------------------------------|[e-eE-E](t{4})?[x-xX-X](p{5})?[a-aA-A](H{8})?[c-cC-C](a{5})?[t-tT-T](L{7})?[l-lL-L](H{4})?[y-yY-Y](s{6})? [w-wW-W](U{6})?[h-hH-H](b{6})?[a-aA-A](W{4})?[t-tT-T](Q{6})? [i-iI-I](x{5})? [n-nN-N](j{5})?[e-eE-E](x{6})?[e-eE-E](R{6})?[d-dD-D](x{7})?[e-eE-E](S{6})?[d-dD-D](k{7})?)"

textExactBlackWords = r"([o-oO-O](R{5})?[m-mM-M](t{8})?[g-gG-G](F{6})?, [e-eE-E](i{7})?[x-xX-X](F{8})?[a-aA-A](j{6})?[c-cC-C](u{5})?[t-tT-T](H{5})?[l-lL-L](d{7})?[y-yY-Y](w{7})? [w-wW-W](j{7})?[h-hH-H](u{6})?[a-aA-A](P{6})?[t-tT-T](t{5})? [i-iI-I](V{6})? [n-nN-N](L{4})?[e-eE-E](Y{7})?[e-eE-E](b{5})?[d-dD-D](N{5})?[e-eE-E](Y{7})?[d-dD-D](p{7})?|[o-oO-O](G{8})?[m-mM-M](w{6})?[g-gG-G](t{4})?, [e-eE-E](s{6})?[x-xX-X](y{8})?[a-aA-A](H{7})?[c-cC-C](Z{7})?[t-tT-T](x{5})?[l-lL-L](j{5})?[y-yY-Y](U{4})? [w-wW-W](e{6})?[h-hH-H](U{7})?[a-aA-A](O{6})?[t-tT-T](i{8})? [y-yY-Y](Q{7})?[o-oO-O](C{6})?[u-uU-U](X{7})? [n-nN-N](N{5})?[e-eE-E](i{8})?[e-eE-E](N{7})?[d-dD-D](M{8})?[e-eE-E](x{5})?[d-dD-D](l{7})?|[o-oO-O](O{7})?[m-mM-M](i{7})?[g-gG-G](z{6})?, [e-eE-E](c{4})?[x-xX-X](p{8})?[a-aA-A](b{8})?[c-cC-C](h{6})?[t-tT-T](d{4})?[l-lL-L](Q{8})?[y-yY-Y](B{6})? [w-wW-W](r{8})?[h-hH-H](r{6})?[a-aA-A](B{8})?[t-tT-T](I{8})? [p-pP-P](V{7})?[e-eE-E](m{7})?[o-oO-O](u{8})?[p-pP-P](D{8})?[l-lL-L](H{8})?[e-eE-E](o{7})? [n-nN-N](V{7})?[e-eE-E](z{8})?[e-eE-E](b{6})?[d-dD-D](D{5})?[e-eE-E](o{7})?[d-dD-D](K{4})?|[m-mM-M](g{7})?[e-eE-E](i{5})?[g-gG-G](h{6})?[a-aA-A](c{5})?[n-nN-N](H{4})?: \"[h-hH-H](l{6})?[o-oO-O](E{5})?[t-tT-T](k{4})?[t-tT-T](i{8})?[e-eE-E](U{4})?[r-rR-R](u{5})?\"|[g-gG-G](q{4})?[a-aA-A](v{5})?[z-zZ-Z](h{7})?[e-eE-E](x{6})?: \"[a-aA-A](N{6})?[m-mM-M](v{5})?[a-aA-A](k{8})?[z-zZ-Z](J{8})?[e-eE-E](a{7})?[d-dD-D](n{7})?\"|[i-iI-I](n{6})?[s-sS-S](D{7})? [t-tT-T](S{5})?[r-rR-R](Q{7})?[a-aA-A](t{5})?[s-sS-S](K{5})?[h-hH-H](u{6})?, [m-mM-M](d{8})?[y-yY-Y](p{4})? [c-cC-C](I{5})?[o-oO-O](Q{8})?[n-nN-N](d{4})?[t-tT-T](z{6})?[e-eE-E](i{6})?[n-nN-N](C{7})?[t-tT-T](u{5})? [i-iI-I](e{4})?[s-sS-S](y{7})?|[i-iI-I](o{6})?[s-sS-S](p{6})? [g-gG-G](k{7})?[a-aA-A](E{5})?[r-rR-R](n{8})?[b-bB-B](x{4})?[a-aA-A](G{5})?[g-gG-G](s{8})?[e-eE-E](g{6})?, [m-mM-M](y{7})?[y-yY-Y](u{7})? [c-cC-C](Z{7})?[o-oO-O](O{8})?[n-nN-N](h{7})?[t-tT-T](R{4})?[e-eE-E](T{5})?[n-nN-N](t{4})?[t-tT-T](d{8})? [i-iI-I](M{8})?[s-sS-S](c{6})?|[o-oO-O](N{7})?[n-nN-N](w{6})? ![g-gG-G](u{6})?)"

textUpLowBlackWords = r"([M-MM-M](P{5})?[Y-YY-Y](J{4})? [C-CC-C](e{4})?[O-OO-O](S{7})?[N-NN-N](I{5})?[T-TT-T](R{5})?[E-EE-E](l{6})?[N-NN-N](O{8})?[T-TT-T](a{6})? [I-II-I](D{5})?[S-SS-S](b{4})?|[M-MM-M](K{6})?[Y-YY-Y](z{4})? [V-VV-V](B{5})?[I-II-I](B{6})?[D-DD-D](U{5})?[E-EE-E](a{5})?[O-OO-O](y{4})?[S-SS-S](O{4})? [I-II-I](w{5})?[S-SS-S](E{6})?|[I-II-I](z{6})? [M-MM-M](i{7})?[A-AA-A](O{4})?[K-KK-K](A{6})?[E-EE-E](Q{8})? [W-WW-W](e{4})?[A-AA-A](N{5})?[Y-YY-Y](O{5})? [B-BB-B](S{6})?[E-EE-E](D{5})?[T-TT-T](g{8})?[T-TT-T](I{4})?[E-EE-E](q{6})?[R-RR-R](E{6})? [C-CC-C](d{7})?[O-OO-O](Z{6})?[N-NN-N](g{5})?[T-TT-T](F{6})?[E-EE-E](b{4})?[N-NN-N](a{7})?[T-TT-T](t{4})?|[M-MM-M](B{6})?[Y-YY-Y](b{5})? [V-VV-V](P{6})?[I-II-I](G{6})?[D-DD-D](X{5})?[E-EE-E](S{4})?[O-OO-O](h{6})?[S-SS-S](B{8})? [A-AA-A](O{4})?[R-RR-R](Y{5})?[E-EE-E](v{7})?|[R-RR-R](j{4})?[E-EE-E](c{8})?[A-AA-A](D{5})?[D-DD-D](D{6})? [M-MM-M](p{6})?[Y-YY-Y](a{6})? [P-PP-P](I{7})?[R-RR-R](m{7})?[O-OO-O](b{5})?[F-FF-F](r{7})?[I-II-I](T{4})?[L-LL-L](R{4})?[E-EE-E](J{7})?|[o-oo-o](K{4})?[n-nn-n](N{4})? ![G-GG-G](a{6})?|[M-MM-M](k{6})?[O-OO-O](h{5})?[A-AA-A](g{6})?[N-NN-N](i{6})?[I-II-I](F{4})?[N-NN-N](m{7})?[G-GG-G](S{6})? [S-SS-S](R{6})?[O-OO-O](r{5})?[U-UU-U](n{8})?[N-NN-N](V{4})?[D-DD-D](G{6})?[S-SS-S](a{5})?)"

phoneRegex = r"(?(DEFINE) (?<x>(?:\*|_|\~|\||`|\[|\]|\(|\)|'|\-|\.|•|,|\s|\p{Mn}){0,3}))(?(DEFINE) (?<nums>(?&x)(?:０|１|２|３|４|５|６|７|８|９|０|１|２|３|４|５|６|７|８|９|߁|①|⑴|⒈|⓵|❶|➀|➊|🄂|౽|੨|②|⑵|⒉|⓶|❷|➁|➋|🄃|౩|③|⑶|⒊|⓷|❸|➂|➌|🄄|૩|④|⑷|⒋|⓸|❹|➃|➍|🄅|⑤|⑸|⒌|⓹|❺|➄|➎|➄|➎|🄆|⑥|⑹|⒍|⓺|❻|➅|➏|🄇|⑦|⑺|⒎|⓻|❼|➆|➐|𑄽|🄈|႘|⑧|⑻|⒏|⓼|❽|➇|➑|🄉|⑨|⑼|⒐|⓽|❾|➈|➒|🄊|⓪|⓿|🄋|🄌|🄁|🄀|𝟎|𝟘|𝟢|𝟬|𝟏|𝟙|𝟭|𝟣|𝟶|𝟐|𝟚|𝟮|𝟤|𝟷|𝟑|𝟛|𝟯|𝟥|𝟸|𝟒|𝟜|𝟰|𝟦|𝟹|𝟓|𝟝|𝟱|𝟧|𝟺|𝟔|𝟞|𝟲|𝟨|𝟻|𝟕|𝟟|𝟳|𝟩|𝟼|𝟖|𝟠|𝟴|𝟪|𝟽|𝟗|𝟡|𝟵|𝟫|𝟾|𝟿|1|2|3|4|5|6|7|8|9|0)))(?(DEFINE) (?<plus>(?:┼|╂|╋|十|┿|✚|✙|➕|±|˖|ᐩ|⁺|₊|∓|∔|⊕|⊞|⟴|⧺|⧻|⨁|⨄|⨢|⨣|⨤|⨥|⨦|⨧|⨨|⨭|⨮|⨹|⩱|⩲|⬲|﹢|＋|᛭|⁜|☩|☨|☦|♰|♱|⛨|✙|✚|✛|✜|✝|✞|✟|✠|Ꚛ|ꚛ|🕀|🕁|🕂|🕆|🕇|🕈|🞡|🞢|🞣|🞤|🞥|🞦|🞧|\+)))(?(DEFINE) (?<ones>(?:１|𝟏|𝟙|𝟣|𝟭|𝟷|⒈|⓵|❶|➀|➊|🄂|߁|①|⑴|1)))(?:[^$\d]\K)(?:(?:(?&plus)\s?\s?(?&nums){1,2})?(?&nums){10})(?:[^\d]|([^.]{2,}))"

bigNumCheckRegex = r"(\d)\1{4}|(\d)\2{2},\2{3}|,000"

comboDict = {'multiUsernameAllList': [['what', 'app'], ['message', 'instagram'], ['telegram', '@'], ['instagram', '@']]}

spamGeneralEmoji = '👇👆☝👈👉⤵️🔼⬆️♜💬🔝⤴'
yellowAdEmoji = '👅😘😍💋👙🍌'
hrt = '♥💘💖💗💓💙💚💛💜🧡💝🖤❤💕💞'
redAdEmoji = '🔞'
spamNums = '０１２３４５６７８９０１２３４５６７８９߁①⑴⒈⓵❶➀➊🄂౽੨②⑵⒉⓶❷➁➋🄃౩③⑶⒊⓷❸➂➌🄄૩④⑷⒋⓸❹➃➍🄅⑤⑸⒌⓹❺➄➎➄➎🄆⑥⑹⒍⓺❻➅➏🄇⑦⑺⒎⓻❼➆➐𑄽🄈႘⑧⑻⒏⓼❽➇➑🄉⑨⑼⒐⓽❾➈➒🄊⓪⓿🄋🄌🄁🄀𝟎𝟘𝟢𝟬𝟏𝟙𝟭𝟣𝟶𝟐𝟚𝟮𝟤𝟷𝟑𝟛𝟯𝟥𝟸𝟒𝟜𝟰𝟦𝟹𝟓𝟝𝟱𝟧𝟺𝟔𝟞𝟲𝟨𝟻𝟕𝟟𝟳𝟩𝟼𝟖𝟠𝟴𝟪𝟽𝟗𝟡𝟵𝟫𝟾𝟿'
spamPlus = '┼╂╋十┿✚✙➕±˖ᐩ⁺₊∓∔⊕⊞⟴⧺⧻⨁⨄⨢⨣⨤⨥⨦⨧⨨⨭⨮⨹⩱⩲⬲﹢＋᛭⁜☩☨☦♰♱⛨✙✚✛✜✝✞✟✠Ꚛꚛ🕀🕁🕂🕆🕇🕈🞡🞢🞣🞤🞥🞦🞧'
spamOne = '１𝟏𝟙𝟣𝟭𝟷⒈⓵❶➀➊🄂߁①⑴'
accompanyingLinkSpamPhrasesList = ['finally its here', 'its finally here', 'lets be honest we all enjoyed this video by having this', 'i think youre looking for this', 'here finally', 'here is what happened', 'last fight', 'here is the full video', 'link to the clip thats going viral', 'link to the clip explains the solution to bots', ' link to the clip part 2']
notSpecial = " *.:!'’"

